/*
 *  main.cpp - Main program
 *
 *  Frodo (C) 1994-1997,2002 Christian Bauer
 */

#include "sysdeps.h"

#include "main.h"
#include "C64.h"
#include "Display.h"
#include "Prefs.h"


/*
 *  main_PalmOS.i - Main program, PalmOS specific stuff
 *
 *  Frodo (C) 1994-1997,2002 Christian Bauer
 */
unsigned long ArmletEntrypoint(const void *emulStateP, void *userData68KP,
                               Call68KFuncType *call68KFuncP) __attribute__ ((section ("first")));
                               
/* This is the entry-point to the entire armlet. NB: It must be *FIRST*
   in the object code, which is achieved by including this at the top of
   main.cpp and having main.o as the first file in the linking step.
*/
unsigned long ArmletEntrypoint(const void *emulStateP, void *userData68KP,
                               Call68KFuncType *call68KFuncP)
{
	ArmletData *d=(ArmletData *)userData68KP;

	if (!d) 
		return 1;
	d->emulStateP = emulStateP;
	d->call68k = call68KFuncP;
	d->r10org = GetR10();
	PutR10((uint32) d);
	d->r9org = GetR9();
	Frodo *app = new Frodo(d);
	if (!app) 
	{ 
		if (!d->errCode) 
			d->errCode = ERR_NEW_FRODO;
		return d->errCode;
	}

	app->Run();
	delete app;

  PutR9(d->r9org);
  PutR10(d->r10org);
  return d->errCode;
}

Frodo::Frodo(ArmletData *d)
{
	TheC64 = NULL;
	armletData = d;
}

void Frodo::Run(void)
{
  // Create and start C64
  TheC64 = new C64(armletData);
	if (!TheC64) 
	{
		if (!armletData->errCode) 
			armletData->errCode = ERR_NEW_C64;
		return;
	}

	if (!armletData->errCode)
  	TheC64->Run();

  delete TheC64;
}
